<?php

// no direct access
defined('_JEXEC') or die('Restricted access');

class modCommerceRandomProductsHelper
{
	function getItems($params, $section_id)
	{
		$db	=& JFactory::getDBO();
		$user = JFactory::getUser();
		
		$catid = array();
		$catid[] = $section_id;
		if($params->get('show_cat'))
		{
			$query = "SELECT id FROM #__js_res_category WHERE parent = '$section_id'";
			$db->setQuery( $query );
			if($cats = $db->loadResultArray())
			$catid = array_merge($catid, $cats);
		}

		$sql = "SELECT r.title, r.id,  rc.catid, u.username, u.name, r.user_id, r.type_id
		FROM #__js_res_record AS r
		JOIN #__js_res_record_category rc ON rc.record_id = r.id
		JOIN #__users u ON u.id = r.user_id
		WHERE(r.extime > NOW() OR r.extime = '0000-00-00 00:00:00') AND r.ctime < NOW() AND r.published = '1'
		AND r.access <= ".$user->aid."
		AND rc.catid IN (".implode(', ', $catid).")";
		$ordering = '';
		switch($params->get('module_type'))
		{
			case 'latest': 
				$ordering = " ORDER BY r.ctime DESC "; 
				break;
			case 'random': 
				$ordering = " ORDER BY RAND() ";
				break;
		}
		$sql .= $ordering;
		
		$sql .= " LIMIT 0, ".$params->get('max_items', 2);
		$db->setQuery($sql);
		$list = $db->loadObjectList();

		foreach ($list as $i => $val)
		{
			if($params->get('show_picture'))
			$list[$i]->picture = modCommerceRandomProductsHelper::getFieldInfo($val->id, $val->type_id, 'picture', $user);
			if($params->get('show_price'))
			$list[$i]->price = modCommerceRandomProductsHelper::getFieldInfo($val->id, $val->type_id, 'price', $user);
			if($params->get('show_addtocart'))
			$list[$i]->addtocart = modCommerceRandomProductsHelper::getFieldInfo($val->id, $val->type_id, 'addtocart', $user);
		}
		return $list;
	}

	function getFieldInfo($record_id, $type_id, $field, $user)
	{
		$db	=& JFactory::getDBO();
		$sql = "SELECT v.id, v.record_id, f.id as fid, v.field_value, v.params as vparams, f.filter,
		f.params, f.title, f.type, f.ordering
		FROM #__js_res_record_values as v
		LEFT JOIN #__js_res_fields AS f ON f.id = v.field_id
		WHERE v.record_id = '". $record_id ."'
		AND f.type = '$field' AND f.access <= ".$user->get( 'aid', 0 )
		." AND f.published = 1
		ORDER BY f.ordering ASC ";
		$db->setQuery($sql);
		$field = $db->loadObject();
		return $field;
	}

}
